Program Simulador_S83;

Uses CRT, DOS, PRINTER, JANELA;

Type

 HARDWARE_MEMORIA = Record
                     REM: Integer;  {Registrador de enderecamento de memoria.}
                     RDM: Byte;     {Registrador de dados da memoria.        }
                     RWMEM: Char;   {Flag Leitura => 'R' Gravacao => 'W'     }
                     MEMORIA:       {A mem.do S83 e em Bytes no total de 32Kb}
                      Array [0..4095] of Byte;  {So e usado 4 Kb de memoria. }
                    End;

 HARDWARE_PROCEC = Record
                    REGISTRADOR: Array [0..7] of Integer;
                    CI,                {Contador de instrucoes.            }
                    IT,                {Interrupcao do S83.                }
                    BA,                {Registrador base de enderecamento. }
                    LI,                {Reg. limite de enderecamento.      }
                    RI:                {Registrador de instrucao.          }
                     Integer;
                    CC:                {Codigo de condicao.                }
                     Byte;
                    INTERRUPCAO:       {Flag interr. desabilitada => False.}
                     Boolean;
                   End;

Var

 MEM: HARDWARE_MEMORIA;     {Variaveis da subdivisao memoria.              }
 PRC: HARDWARE_PROCEC;      {Variaveis da subdivisao processador.          }

 JNL: PONTEIRO_PARA_JANELA; {Ponteiro para um pilha de janelas no heap.    }

 OPCAO: Char;               {Opcao fornecida ao usuario no inicio do S83.  }

 CURSORX,
 CURSORY: Integer;          {Posicoes iniciais do cursor na tela.          }

Procedure MEMORIA;

Begin
 If (MEM.RWMEM = 'W')
  Then                                  {Ordem para gravar na memoria. }
    MEM.MEMORIA [MEM.REM] := MEM.RDM    {Passar memoria para Reg.Dados.}
  Else                                  {Ordem para ler da momoria.    }
    MEM.RDM := MEM.MEMORIA [MEM.REM]    {Passar Reg.Dados para Memoria.}
End;

Procedure LE_ARQUIVO;

Var

 NOMEARQ: String [40]; {Nome do arquivo de dados, inclusive com diretorios.}
 TEXTO: Text;          {O arquivo sera do modo texto,  caract. a caract.   }
 ARQCARACT: Char;      {Variavel que contera o caracter lido do arquivo.   }
 ENDERINICIAL,         {Indica se o ender.necessita de tratamento especial.}
 ENDERECO: Boolean;    {Indica se o carac. e de endereco ou de dados comum.}
 HEXALIDOS,            {Indica qts carac.hexa foram lidos.1 linha=20 hexas.}
 CONTCARACT,           {Contador de controle de caracteres validos lidos.  }
 VALORACUM: Integer;   {Acumulador de val.representados pelos digitos hexa.}

 CONTINUAR: Char;      {Variavel que indica se o usuario deseja continuar. }

 EXISTE: Boolean;      {Indica se o arquivo solicitado existe ou nao.      }

 Function EXISTE_ARQUIVO (NOMEARQ: String): Boolean;

 {Constata a existencia do arquivo.}

  Var

   ARQ: File;

  Begin
   {$I-}                               {Desabilita mensagens de erro.}
   Assign (ARQ, NOMEARQ);
   Reset (ARQ);
   Close (ARQ);
   {$I+}                               {Volta a verificar erros.     }
   EXISTE_ARQUIVO := (IOResult = 0) and (NOMEARQ <> '')
          {    Indica se durante a abertura do arquivo houve erros
            ou nao. True = existe, False = o arquivo nao existe.     }
  End;

 Function VALOR (CARACTER: Char): Integer;

         {   Tem a finalidade de retornar o valor em decimal de uma
          vaiavel contendo um digito hexadecimal.                    }

 Var

  ERRO,                  {Contera o codigo de erro. Obs.nao ha erros.}
  NUMERO: Integer;         {Numero referente a transformacao do hexa.}

 Begin
  If (CARACTER >= '0') And (CARACTER <= '9') {Se for um val. numerico}
   Then
    Begin
     Val (CARACTER, NUMERO, ERRO);          {Transforme naturalmente.}
     VALOR:=NUMERO
    End
   Else                               {Senao escolha o valor correto.}
    Case CARACTER of
     'A','a': VALOR:=10;
     'B','b': VALOR:=11;
     'C','c': VALOR:=12;
     'D','d': VALOR:=13;
     'E','e': VALOR:=14;
     'F','f': VALOR:=15;
    End
 End;

Begin
 CONTINUAR:='S';
 SALVE_JANELA (1,10,8,70,JNL);
 MOLDURA (1,10,8,70,1);        { Janela para entrada do arquivo de dados.}
 Repeat
  ClrScr;
  WriteLn;
  WriteLn ('    Entre com o nome do arquivo programa do S83:');
  Write ('    Arquivo: ');
  ReadLn (NOMEARQ);
  EXISTE := EXISTE_ARQUIVO (NOMEARQ);
  If Not EXISTE
   Then
    Begin
     WriteLn ('    Nao existe: ',NOMEARQ);
     Write ('    Deseja entrar com um novo nome de arquivo? (S/N): ');
     ReadLn (CONTINUAR)
    End;
 Until EXISTE or (CONTINUAR='N') or (CONTINUAR='n');
 FECHE_JANELA (JNL);
 Window (1,1,80,25);
 If EXISTE
  Then
   Begin
    Assign (TEXTO, NOMEARQ);
    Reset (TEXTO);
    FillChar (MEM.MEMORIA,4096,0);  {Zere a memoria inteira. 4Kb        }
    ENDERINICIAL:=True;             {A seq. tera um tratamento especial.}
    ENDERECO:=True;                 {A seq. e um endereco e nao um dado.}
    HEXALIDOS:=0;                   {Nao foi lido nenhum dado hexadecim.}
    CONTCARACT:=0;                  {Inicializa cont. de contr.interno. }
    VALORACUM:=0;                   {Inicializa acum. de contr.interno. }
    While (Not Eof (TEXTO)) do
     Begin
      Read (TEXTO, ARQCARACT);
      If (((ARQCARACT >= '0') and (ARQCARACT <= '9')) or
          ((ARQCARACT >= 'A') and (ARQCARACT <= 'F')) or
          ((ARQCARACT >= 'a') and (ARQCARACT <= 'f')))
       Then                    {E um caracter valido.                      }
        If ENDERECO            {E um endereco ou um dado hexadecimal comum?}
         Then
          If ENDERINICIAL      {E um endereco no inicio do arquivo ou nao? }
           Then
            Begin
             Case CONTCARACT of

               {     Os 4 primeiros caracteres validos serao ignorados,
                porque sempre serao de valor 0, por se tratar  da  pri-
                meira palavra reservada da memoria.                   }

               {     Os case de numero 4,5,6 e 7 sao  o  valor  corres-
                pondente ao endereco inicial do programa do S83.      }
               4: VALORACUM:=VALORACUM+(VALOR(ARQCARACT)*4096);
               {   O valor 4096 e 16*16*16 que e multiplicado pelo va-
                lor do ascii de posicao inicial X ou seja XEEE.       }
               5: VALORACUM:=VALORACUM+(VALOR(ARQCARACT)*256);
               {   O valor 256 e 16*16 que corresponde a posicao EXEE
                do digito hexadecimal lido pelo programa.             }
               6: VALORACUM:=VALORACUM+(VALOR(ARQCARACT)*16);
               {   Soma-se o valor correspondente a posicao EEXE do ca-
               racter.                                                }
               7: Begin
                   VALORACUM:=VALORACUM+VALOR(ARQCARACT);
                   { Soma-se a posicao final EEEX }
                   MEM.REM:=0;
                   MEM.RDM:=Hi (VALORACUM);
                   {Prim.Byte da memoria recebe o byte mais singnificativo.}
                   MEM.RWMEM:='W'; {Gravar na memoria}
                   MEMORIA;        {Chame controle de memoria.(Tranferir dado)}
                   Inc (MEM.REM);  {Proximo endereco.}
                   MEM.RDM:=Lo (VALORACUM);
                   {Seg.Byte da memoria recebe o byte menos singnificativo.}
                   MEMORIA;  {Chame o controle de memoria}
                   MEM.REM:=VALORACUM;
                   { O programa sera colocado neste endereco.}
                   VALORACUM:=0;
                  End;

               {     Ignorar os quatro bytes depois dos dois hexas li-
               dos. Pois sao referentes a um endereco que ja e sabido. }

              11: Begin
                   ENDERINICIAL:=False; {Ja foi tratado o endereco inicial.}
                   ENDERECO:=False;     {O proximo dado sera um dado comum.}
                   CONTCARACT:=-1
                  End

             End;
             Inc (CONTCARACT)
            End
           Else
            Begin
             {Ignorar o endereco de dados pois eles obedecem uma sequencia.}
             If (CONTCARACT=3)
              Then             {O endereco ja foi ignorado.}
               Begin
                CONTCARACT:=0;
                ENDERECO:=False  {O proximo dado nao e um end. e sim um dado}
               End
              Else
               Inc (CONTCARACT)
             End
         Else
          If (CONTCARACT=0)
           Then     {Prosiga se for primeiro dos dois digitos hexa decimais.}
            Begin
             VALORACUM:=VALORACUM+(VALOR(ARQCARACT)*16);
             { Acumule o seu valor correspondente.}
             CONTCARACT:=1
            End
           Else
            Begin
             VALORACUM:=VALORACUM+VALOR(ARQCARACT);
             {Complemente o acumulador com o valor do segundo digito hexa.}
             CONTCARACT:=0;
             HEXALIDOS:=HEXALIDOS+1;
             MEM.RWMEM:='W';          {Gravar na memoria}
             MEM.RDM:=VALORACUM;      {Reg.Dados da Mem. recebe o valor.}
             MEMORIA;                 {Chame o controle de memoria.}
             Inc (MEM.REM);           {Incremente o Reg.End.Mem.}
             VALORACUM:=0;
             If (HEXALIDOS=20)
              Then
               Begin                  {Se for o ultimo dado hexadecimal}
                ENDERECO:=True;
                HEXALIDOS:=0          {Entao o proximo sera de endereco.}
               End
            End
     End
   End
End;

Procedure DUMP;

Type

 STRHEXA = String [2]; {Um byte representado na base 16}

Var

 VALHEXADEC: STRHEXA;

 CONTADOR,
 INDICE: Integer;    {Contadores para controle interno.}

 TECLA,
 OPCAO: Char;          {Controle de andamento do dump pelo usuario.}

 CENTSEG,
 SEG,
 MIN,
 HORA,
 DIA,
 MES,
 ANO,
 DIASEM: Word;   {Identificacao da simulacao e dump realizados.}

 Procedure HEXA (VALOR: Byte; Var RESULTHEXA: STRHEXA);

 Const

  HEXACODIG: Array [0 .. 15] of Char = '0123456789ABCDEF';

 Begin
  RESULTHEXA [1]:=HEXACODIG [VALOR Div 16];
  {  Passa para a primeira posicao do RESULTHEXA o ASCII referente
   ao valor do byte mais singnifictivo do valor fornecido.}
  RESULTHEXA [2]:=HEXACODIG [VALOR and 15]
  {  O mesmo ocorre com a segunda posicao do RESULTHEXA que resebe
   o ASCII referente aos quatro bits da direita do byte.  }
 End;

Begin
 SALVE_JANELA (5,5,20,75,JNL);
 MOLDURA (5,5,20,75,1);
 ClrScr;                          {Abre a janela do Dump.}
 Window (8,6,74,19);
 Write ('Executar o Dump de memoria na [T]eta ou [I]mpressora [ ]');
 GotoXY (55, 1);
 ReadLn (OPCAO);
 If (OPCAO = 'I') or (OPCAO = 'i')
  Then
   Begin
    WriteLn;
    Write ('Mandar o DUMP para a impressora.')
   End;
 GetDate (ANO, MES, DIA, DIASEM);
 GetTime (HORA, MIN, SEG, CENTSEG);
 MEM.RWMEM:='R';
 For CONTADOR:=0 to 4095 do      {Percorra a memoria inteira}
  Begin
   MEM.REM:=CONTADOR;
   MEMORIA;
   If (CONTADOR = 0) or ((CONTADOR mod 100)=0)
    Then
     If (OPCAO <> 'I') and (OPCAO <> 'i')
      Then
       Begin                   {So imprime na tela.}
        If (CONTADOR <> 0)
         Then
          Begin
           TECLA:=ReadKey;
           ClrScr
          End;
        Write ('Data simulacao: ',DIA:2,'/',MES:2,'/',ANO:2);
        WriteLn ('    Hora: ',HORA:2,':',MIN:2,':',SEG:2);
        WriteLn;
        HEXA (Hi (PRC.CI), VALHEXADEC);
        Write ('Registradores: CI:',VALHEXADEC [1], VALHEXADEC [2]);
        HEXA (Lo (PRC.CI), VALHEXADEC);
        WriteLn (VALHEXADEC [1], VALHEXADEC [2]);
        HEXA (Hi (PRC.CC), VALHEXADEC);
        Write ('               CC:',VALHEXADEC [1], VALHEXADEC [2]);
        HEXA (Lo (PRC.CC), VALHEXADEC);
        WriteLn (VALHEXADEC [1], VALHEXADEC [2]);
        HEXA (Hi (PRC.BA), VALHEXADEC);
        Write ('             Base:',VALHEXADEC [1], VALHEXADEC [2]);
        HEXA (Lo (PRC.BA), VALHEXADEC);
        WriteLn (VALHEXADEC [1], VALHEXADEC [2]);
        HEXA (Hi (PRC.LI), VALHEXADEC);
        Write ('           Limite:',VALHEXADEC [1], VALHEXADEC [2]);
        HEXA (Lo (PRC.LI), VALHEXADEC);
        WriteLn (VALHEXADEC [1], VALHEXADEC [2]);
        WriteLn;
        For INDICE:=0 to 7 do
         Begin
          HEXA (Hi (PRC.REGISTRADOR[INDICE]), VALHEXADEC);
          Write ('R',INDICE:1,' ',VALHEXADEC [1], VALHEXADEC [2]);
          HEXA (Lo (PRC.REGISTRADOR[INDICE]), VALHEXADEC);
          Write (VALHEXADEC [1], VALHEXADEC [2],' ')
         End;
        WriteLn
       End;
   If ((OPCAO = 'I') or (OPCAO = 'i')) and ((CONTADOR mod 1000)=0)
    Then
     Begin
      If CONTADOR <> 0
       Then
        Begin
         WriteLn (Lst); WriteLn (Lst); WriteLn (Lst); WriteLn (Lst);
         WriteLn (Lst); WriteLn (Lst); WriteLn (Lst); WriteLn (Lst);
        End;
      Write (Lst,'Data simulacao: ',DIA:2,'/',MES:2,'/',ANO:2);
      WriteLn (Lst,'    Hora: ',HORA:2,':',MIN:2,':',SEG:2);
      WriteLn (Lst);
      HEXA (Hi (PRC.CI), VALHEXADEC);
      Write (Lst,'Registradores: CI:',VALHEXADEC [1], VALHEXADEC [2]);
      HEXA (Lo (PRC.CI), VALHEXADEC);
      WriteLn (Lst,VALHEXADEC [1], VALHEXADEC [2]);
      HEXA (Hi (PRC.CC), VALHEXADEC);
      Write (Lst,'               CC:',VALHEXADEC [1], VALHEXADEC [2]);
      HEXA (Lo (PRC.CC), VALHEXADEC);
      WriteLn (Lst,VALHEXADEC [1], VALHEXADEC [2]);
      HEXA (Hi (PRC.BA), VALHEXADEC);
      Write (Lst,'             Base:',VALHEXADEC [1], VALHEXADEC [2]);
      HEXA (Lo (PRC.BA), VALHEXADEC);
      WriteLn (Lst,VALHEXADEC [1], VALHEXADEC [2]);
      HEXA (Hi (PRC.LI), VALHEXADEC);
      Write (Lst,'           Limite:',VALHEXADEC [1], VALHEXADEC [2]);
      HEXA (Lo (PRC.LI), VALHEXADEC);
      WriteLn (Lst,VALHEXADEC [1], VALHEXADEC [2]);
      WriteLn (Lst);
      For INDICE:=0 to 7 do
       Begin
        HEXA (Hi (PRC.REGISTRADOR[INDICE]), VALHEXADEC);
        Write (Lst,'R',INDICE:1,' ',VALHEXADEC [1], VALHEXADEC [2]);
        HEXA (Lo (PRC.REGISTRADOR[INDICE]), VALHEXADEC);
        Write (Lst,VALHEXADEC [1], VALHEXADEC [2],' ');
       End;
      WriteLn (Lst)
     End;
   If ((CONTADOR mod 20)=0)
    Then {Se for um multiplo de 20 imprima o endereco correspondente.}
     If (OPCAO = 'I') or (OPCAO = 'i')
      Then
       Begin               {Impressora.}
        WriteLn (Lst);
        HEXA (Hi (CONTADOR), VALHEXADEC);
        Write (Lst,VALHEXADEC [1], VALHEXADEC [2]);
        HEXA (Lo (CONTADOR), VALHEXADEC);
        Write (Lst,VALHEXADEC [1], VALHEXADEC [2])
       End
      Else
       Begin               {Tela.}
        WriteLn;
        HEXA (Hi (CONTADOR), VALHEXADEC);
        Write (VALHEXADEC [1], VALHEXADEC [2]);
        HEXA (Lo (CONTADOR), VALHEXADEC);
        Write (VALHEXADEC [1], VALHEXADEC [2])
       End;
    HEXA (MEM.RDM, VALHEXADEC);  {Transforme para hexa o dado da memoria.}
    If (OPCAO = 'I') or (OPCAO = 'i')
     Then
      Write (Lst,' ',VALHEXADEC [1], VALHEXADEC [2])               {Imprima-o.}
     Else
      Write (' ',VALHEXADEC [1], VALHEXADEC [2])               {Imprima-o.}
  End;
 If (OPCAO <> 'I') and (OPCAO <> 'i')
  Then
   TECLA:=ReadKey;
 FECHE_JANELA (JNL)
End;

Procedure PROCESSA;

 Var

  TECLA: Char; { Esperar por um enter do usuario para prosseguir.}

 Function LE_INSTRUCAO: Integer;

 {A instrucao e tirada a partir do endereco do Contador de Instrucao.}

 Begin
  MEM.RWMEM:='R';
  MEM.REM:=PRC.CI;
  MEMORIA;
  LE_INSTRUCAO:=MEM.RDM div 4
  {   Retorna o Byte sem os dois bits do operando dois. Ou seja, somente
   a instrucao, os dois bits do operando dois permanecem no Reg.de Dados
   da Memoria, porque teram que ser tratados posteriormente pela  funcao
   Le_Seg_Operando.}
 End;

 Function LE_PRIM_OPERANDO: Byte;

 {  Esta funcao deve ser chamada logo apos a chamada de uma procedure
  que trata um comando, porque ela trata os  dois  bits  deixados  no
  Reg.de Dados da Memoria pela funcao Le_Instrucao.                 }

 Var

  PRIM_DOIS_BITS: Byte;

 Begin
  PRIM_DOIS_BITS:=(MEM.RDM and 3)*2;
  {  Pega somente os dois bits da direita (Pedaco do operando dois e
   gira-os um bit para a esquerda.                                 }
  MEM.RWMEM:='R';
  MEM.REM:=PRC.CI+1;
  MEMORIA;
  LE_PRIM_OPERANDO:=PRIM_DOIS_BITS+(MEM.RDM div 128);
  { Soma os dois primeiros bits com o terceiro bit do segundo byte.}
 End;

 Function LE_SEG_OPERANDO: Integer;

 {  Deve ser chamada logo apos da chamada da funcao Le_Seg_Operando,
  pois ela supoem que o segundo byte da instrucao ainda esta no Reg.
  de Dados da Memoria.                                             }

 Var

  PARTE_ANTERIOR_PRIM_OPERANDO: Integer;

 Begin
  PARTE_ANTERIOR_PRIM_OPERANDO:=(MEM.RDM and 127);
  { Ignora o primeiro bit pois ele pertence ao primeiro operando.}
  MEM.RWMEM:='R';
  MEM.REM:=PRC.CI+2;
  MEMORIA;
  LE_SEG_OPERANDO:=(PARTE_ANTERIOR_PRIM_OPERANDO*256)+MEM.RDM
  { Junta o valor do segunda byte com o do terceiro e retorna a soma.}
 End;

 Procedure SOMA;                       { Soma o conteudo da palavra indicada
                                        pelo segundo operando com o registra-
                                        dor indicado pelo primeiro operando.
                                        O resultado fica no registrador e  o
                                        Codigo de Condicao e atualizado.    }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;
  PALAVRA_DA_MEMORIA_FORMATO_WORD: Word;
                               { Contem o conteudo da palavra de memoria
                                indicado pelo segundo operando sem o sinal.}
  PALAVRA_DA_MEMORIA_FORMATO_INTEGER: Integer;
                               { Contem o conteudo da palavra de memoria
                                indicado pelo segundo operando com o sinal.}
  TESTE_OVERFLOW: LongInt;    { Verificacao da soma em caso de overflow.}

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  MEM.REM:=PRC.BA + SEG_OPERANDO;
  If (MEM.REM + 1) > PRC.LI
  { O endereco pertence ao intervalo permitido? }
   Then
    PRC.IT:=1                { Estouro do limite.}
   Else
    Begin
     MEM.RWMEM:='R';
     MEMORIA;                             { Le o byte mais singnificativo}
     PALAVRA_DA_MEMORIA_FORMATO_WORD:=MEM.RDM * 256;
     { Avalia e coloca o seu valor correspondente.}
     Inc (MEM.REM);
     MEMORIA;                             { Le o byte menos singnificativo}
     Inc (PALAVRA_DA_MEMORIA_FORMATO_WORD, MEM.RDM);
     { Adiciona na variavel no formato de word.}
     PALAVRA_DA_MEMORIA_FORMATO_INTEGER:=PALAVRA_DA_MEMORIA_FORMATO_WORD;
     { A passagem do valor de uma variavel word para uma variavel do
      tipo integer e necessaria para se levar em conta o sinal.     }
     TESTE_OVERFLOW:=PALAVRA_DA_MEMORIA_FORMATO_INTEGER;
     Inc (TESTE_OVERFLOW, PRC.REGISTRADOR [PRIM_OPERANDO]);
     { Confia o resultado na variavel Teste_Overflow, pois ela
      pode identificar um estouro de capacidade de armazenamento.}
     If (TESTE_OVERFLOW > MAXINT) or (TESTE_OVERFLOW < (-MAXINT-1))
      Then
       PRC.IT:=3
      Else
       Begin
        PRC.REGISTRADOR [PRIM_OPERANDO]:=TESTE_OVERFLOW;
        If (PRC.REGISTRADOR [PRIM_OPERANDO] < 0)
         Then
          PRC.CC:=4
         Else
          If (PRC.REGISTRADOR [PRIM_OPERANDO] > 0)
           Then
            PRC.CC:=2
           Else
            PRC.CC:=1
       End
    End;
  Inc (PRC.CI,3) {Incrementa o Contador de Instrucao para a nova instrucao.}
 End;

 Procedure SUB;                       { Subtrai o conteudo da palavra indicada
                                        pelo segundo operando com o  registra-
                                        dor indicado pelo primeiro operando.
                                        O resultado fica no registrador e  o
                                        Codigo de Condicao e atualizado.    }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;
  PALAVRA_DA_MEMORIA_FORMATO_WORD: Word;
                               { Contem o conteudo da palavra de memoria
                                indicado pelo segundo operando sem o sinal.}
  PALAVRA_DA_MEMORIA_FORMATO_INTEGER: Integer;
                               { Contem o conteudo da palavra de memoria
                                indicado pelo segundo operando com o sinal.}
  TESTE_OVERFLOW: LongInt;    { Verificacao da soma em caso de overflow.}

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  MEM.REM:=PRC.BA + SEG_OPERANDO;
  If (MEM.REM + 1 > PRC.LI)
  { O endereco pertence ao intervalo permitido? }
   Then
    PRC.IT:=1                { Estouro do limite.}
   Else
    Begin
     MEM.RWMEM:='R';
     MEMORIA;                             { Le o byte mais singnificativo}
     PALAVRA_DA_MEMORIA_FORMATO_WORD:=MEM.RDM * 256;
     { Avalia e coloca o seu valor correspondente.}
     Inc (MEM.REM);
     MEMORIA;                             { Le o byte menos singnificativo}
     Inc (PALAVRA_DA_MEMORIA_FORMATO_WORD, MEM.RDM);
     { Adiciona na variavel no formato word.}
     PALAVRA_DA_MEMORIA_FORMATO_INTEGER:=PALAVRA_DA_MEMORIA_FORMATO_WORD;
     { A passagem do valor de uma variavel word para uma variavel do
      tipo integer e necessaria para se levar em conta o sinal.     }
     TESTE_OVERFLOW:=PALAVRA_DA_MEMORIA_FORMATO_INTEGER;
     Dec (TESTE_OVERFLOW, PRC.REGISTRADOR [PRIM_OPERANDO]);
     { Confia o resultado na variavel Teste_Overflow, pois ela
      pode identificar um estouro de capacidade de armazenamento.}
     If (TESTE_OVERFLOW > MAXINT) or (TESTE_OVERFLOW < (-MAXINT-1))
      Then
       PRC.IT:=3
      Else
       Begin
        PRC.REGISTRADOR [PRIM_OPERANDO]:=TESTE_OVERFLOW;
        If (PRC.REGISTRADOR [PRIM_OPERANDO] < 0)
         Then
          PRC.CC:=4
         Else
          If (PRC.REGISTRADOR [PRIM_OPERANDO] > 0)
           Then
            PRC.CC:=2
           Else
            PRC.CC:=1
       End
    End;
  Inc (PRC.CI,3) {Incrementa o Contador de Instrucao para a nova instrucao.}
 End;

 Procedure MUL;                        { Multiplica a palavra enderecada pelo
                                        segundo operando com o registrado in-
                                        dicado pelo primeiro operando. O  re-
                                        sultado fica no registrador e o Codi-
                                        go de condicao e  atualizado  devida-
                                        mente.                               }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;
  MULTIPLICADOR_FORMATO_WORD: Word;       { Variavel sem sinal.}
  MULTIPLICADOR_FORMATO_INTEGER: Integer; { Variavel com sinal.}
  TESTE_OVERFLOW: LongInt; { Variavel para avaliar a expressao.}

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  MEM.REM:=PRC.BA + SEG_OPERANDO;
  If (MEM.REM + 1) > PRC.LI {Estourou o limite de enderecamento?}
   Then
    PRC.IT:=1
   Else
    Begin
     MEM.RWMEM:='R';
     MEMORIA;
     MULTIPLICADOR_FORMATO_WORD:=MEM.RDM * 256;
     Inc (MEM.REM);
     MEMORIA;
     Inc (MULTIPLICADOR_FORMATO_WORD, MEM.RDM);
     MULTIPLICADOR_FORMATO_INTEGER:=MULTIPLICADOR_FORMATO_WORD;
     TESTE_OVERFLOW:=PRC.REGISTRADOR [PRIM_OPERANDO];
     TESTE_OVERFLOW:=TESTE_OVERFLOW * MULTIPLICADOR_FORMATO_INTEGER;
     If (TESTE_OVERFLOW < (-MAXINT-1)) or (TESTE_OVERFLOW > MAXINT)
            {Estourou o limite de uma variavel inteira?}
      Then
       PRC.IT:=3
      Else
       Begin
        PRC.REGISTRADOR [PRIM_OPERANDO]:=TESTE_OVERFLOW;
        If PRC.REGISTRADOR [PRIM_OPERANDO] < 0
         Then
          PRC.CC:=4
         Else
          If PRC.REGISTRADOR [PRIM_OPERANDO] > 0
           Then
            PRC.CC:=2
           Else
            PRC.CC:=1
       End
    End;
  Inc (PRC.CI,3) {Incrementa o Contador de Instrucao para a nova instrucao.}
 End;

 Procedure DIVI;                       { Divide o registrador indicado pelo
                                        primeiro operando com a palavra in-
                                        dicada pelo segundo operando. O re-
                                        sultado fica no registrador e o Co-
                                        digo de Condicao e atualizado devi-
                                        damente.                           }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;
  DIVISOR_FORMATO_WORD: Word;
  DIVISOR_FORMATO_INTEGER: Integer;
  TESTE_OVERFLOW: LongInt;

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  MEM.REM:=PRC.BA + SEG_OPERANDO;
  If (MEM.REM + 1) > PRC.LI
   Then
    PRC.IT:=1
   Else
    Begin
     MEM.RWMEM:='R';
     MEMORIA;
     DIVISOR_FORMATO_WORD:=MEM.RDM * 256;
     Inc (MEM.REM);
     MEMORIA;
     Inc (DIVISOR_FORMATO_WORD, MEM.RDM);
     If DIVISOR_FORMATO_WORD = 0
      Then
       PRC.IT:=4
      Else
       Begin
        DIVISOR_FORMATO_INTEGER:=DIVISOR_FORMATO_WORD;
        TESTE_OVERFLOW:=PRC.REGISTRADOR [PRIM_OPERANDO];
        TESTE_OVERFLOW:=TESTE_OVERFLOW Div DIVISOR_FORMATO_INTEGER;
        PRC.REGISTRADOR [PRIM_OPERANDO]:=TESTE_OVERFLOW;
        If PRC.REGISTRADOR [PRIM_OPERANDO] < 0
         Then
          PRC.CC:=4
         Else
          If PRC.REGISTRADOR [PRIM_OPERANDO] > 0
           Then
            PRC.CC:=2
           Else
            PRC.CC:=1
       End
    End;
  Inc (PRC.CI,3) {Incrementa o Contador de Instrucao para a nova instrucao.}
 End;

 Procedure DD;                         {  Desloca os bits do registrador
                                        para a direita o numero de vezes
                                        indicado pelos quatro ultimos
                                        bits do operando 2.             }
 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  SEG_OPERANDO:=SEG_OPERANDO and 15;   {15 = 0FH = 0000 1111B}
  {Zera tudo que nao for os 4 ultimos bits.}
  PRC.REGISTRADOR [PRIM_OPERANDO]:=
   PRC.REGISTRADOR [PRIM_OPERANDO] shr SEG_OPERANDO;
  { Desloca para a direita os bits do registrador escolhido n vezes,
   o n e dado pelos 4 bits do operando dois.}
  If PRC.REGISTRADOR [PRIM_OPERANDO] < 0  {Atualiza o Codigo de Condicao.}
   Then
    PRC.CC:=4
   Else
    If PRC.REGISTRADOR [PRIM_OPERANDO] > 0
     Then
      PRC.CC:=2
     Else
      PRC.CC:=1;
  Inc (PRC.CI,3) {Incrementa o Contador de Instrucao para a nova instrucao.}
 End;

 Procedure DE;                         {  Desloca os bits do registrador
                                        para a esquerda o numero de  ve-
					zes indicado pelos quatro  ulti-
					mos bits do operando 2.         }
 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  SEG_OPERANDO:=SEG_OPERANDO and 15;
  {Zera tudo que nao for os 4 ultimos bits.}
  PRC.REGISTRADOR [PRIM_OPERANDO]:=
  PRC.REGISTRADOR [PRIM_OPERANDO] shl SEG_OPERANDO;
  { Desloca para a direita os bits do registrador escolhido n vezes,
   o n e dado pelos 4 bits do operando dois.}
  If PRC.REGISTRADOR [PRIM_OPERANDO] < 0  {Atualiza o Codigo de Condicao.}
   Then
    PRC.CC:=4
   Else
    If PRC.REGISTRADOR [PRIM_OPERANDO] > 0
     Then
      PRC.CC:=2
     Else
      PRC.CC:=1;
  Inc (PRC.CI,3) {Incrementa o Contador de Instrucao para a nova instrucao.}
 End;

 Procedure CB;                         { Carrega no registrador Base o Con-
                                        teudo do Contador de Instrucao.    }

 Begin
  PRC.BA:=PRC.CI;
  Inc (PRC.CI)
 End;

 Procedure CL;                         { Carrega no registrador Limite o
                                        conteudo do segundo operando.    }

  Var

   PRIM_OPERANDO: Byte;
   SEG_OPERANDO: Integer;

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
   { O primeiro operando nao interfere no andamento da instrucao CL, mas
    ele deve ser lido pois a funcao Le_Seg_Operando necessita que o pri-
    meiro operando seja lido, pois a funcao Le_Seg_Operando considera  o
    valor deixado no registrador de dados da memoria, como  parte  inte-
    grante do seu valor.                                                }
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  PRC.LI:=PRC.BA + SEG_OPERANDO;
  Inc (PRC.CI,3)
 End;

 Procedure E;                          {  Executa a operacao and nos bits
                                         de mais baixa ordem  da  palavra
                                         indicada pelo operando dois e  o
                                         byte de mais baixa ordem do  re-
                                         gistrador indicado pelo primeiro
                                         operando.                       }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  MEM.RWMEM:='R';
  MEM.REM:=PRC.BA+SEG_OPERANDO;
  {Endereco da palavra de memoria.}
  If (MEM.REM + 1) > PRC.LI {Estorou o limeite? }
   Then
    PRC.IT:=1  {Se sim entao interrupcao de limite de enderecamento.}
   Else
    Begin
     Inc (MEM.REM); {Aponte para o byte menos singnificativo da palavra.}
     MEMORIA;   {Se nao chame a memoria para ler o dado.}
     PRC.REGISTRADOR [PRIM_OPERANDO]:=
      Hi (PRC.REGISTRADOR [PRIM_OPERANDO]) +
      (Lo (PRC.REGISTRADOR [PRIM_OPERANDO]) and MEM.RDM);
     {  Execute a operacao and entre os dois bytes e
      guarde o resultado no byte menos singnificativo do registrador.}
     If PRC.REGISTRADOR [PRIM_OPERANDO] < 0   {Atualiza o Codigo de Condicao.}
      Then
       PRC.CC:=4
      Else
       If PRC.REGISTRADOR [PRIM_OPERANDO] > 0
        Then
         PRC.CC:=2
        Else
         PRC.CC:=1
    End;
  Inc (PRC.CI,3) {Faca o Contador de Instrucao apontar para a nova instr.}
 End;

 Procedure OU;                         {  Executa a operacao or  no  byte
                                         de mais baixa ordem  da  palavra
                                         indicada pelo operando dois e  o
                                         byte de mais baixa ordem do  re-
                                         gistrador indicado pelo primeiro
                                         operando.                       }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  MEM.RWMEM:='R';
  MEM.REM:=PRC.BA+SEG_OPERANDO;
  {Endereco da palavra de memoria.}
  If (MEM.REM +1)> PRC.LI {Estorou o limeite? }
   Then
    PRC.IT:=1  {Se sim entao interrupcao de limite de enderecamento.}
   Else
    Begin
     Inc (MEM.REM); {Aponte para o byte menos singnificativo.}
     MEMORIA;   {Se nao chame a memoria para ler o dado.}
     PRC.REGISTRADOR [PRIM_OPERANDO]:=
      Hi (PRC.REGISTRADOR [PRIM_OPERANDO] +
      (Lo (PRC.REGISTRADOR [PRIM_OPERANDO]) or MEM.RDM));
     {  Execute a operacao ou entre os dois e
      guarde o resultado no registrador.      }
     If PRC.REGISTRADOR [PRIM_OPERANDO] < 0   {Atualiza o Codigo de Condicao.}
      Then
       PRC.CC:=4
      Else
       If PRC.REGISTRADOR [PRIM_OPERANDO] > 0
        Then
         PRC.CC:=2
        Else
         PRC.CC:=1
    End;
  Inc (PRC.CI,3) {Faca o Contador de Instrucao apontar para a nova instr.}
 End;

 Procedure OUX;                        {  Executa a operacao oux nos bits
                                         de mais baixa ordem  da  palavra
                                         indicada pelo operando dois e  o
                                         byte de mais baixa ordem do  re-
                                         gistrador indicado pelo primeiro
                                         operando.                       }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  MEM.RWMEM:='R';
  MEM.REM:=PRC.BA+SEG_OPERANDO;
  {Endereco da palavra de memoria.}
  If (MEM.REM + 1) > PRC.LI {Estorou o limeite? }
   Then
    PRC.IT:=1  {Se sim entao interrupcao de limite de enderecamento.}
   Else
    Begin
     Inc (MEM.REM); {Aponte para o byte menos singnificativo.}
     MEMORIA;   {Se nao chame a memoria para ler o dado.}
     PRC.REGISTRADOR [PRIM_OPERANDO]:=
      Hi (PRC.REGISTRADOR [PRIM_OPERANDO] +
      (Lo (PRC.REGISTRADOR [PRIM_OPERANDO]) xor MEM.RDM));
     {  Execute a operacao oux entre os dois e
      guarde o resultado no registrador.      }
     If PRC.REGISTRADOR [PRIM_OPERANDO] < 0   {Atualiza o Codigo de Condicao.}
      Then
       PRC.CC:=4
      Else
       If PRC.REGISTRADOR [PRIM_OPERANDO] > 0
        Then
         PRC.CC:=2
        Else
         PRC.CC:=1
    End;
  Inc (PRC.CI,3) {Faca o Contador de Instrucao apontar para a nova instr.}
 End;

 Procedure CBT;                        {  Compara o byte de mais baixa  ordem
                                        da palavra indicada pelo segundo ope-
                                        rando com o byte de mais baixa  ordem
                                        do registrador atualizando  convenien
                                        temente o Codigo de Condicao.        }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  MEM.RWMEM:='R';
  MEM.REM:=PRC.BA+SEG_OPERANDO;
  If (MEM.REM+1) > PRC.LI {Ao ler a palavra inteira, vai estourar o limite? }
   Then
    PRC.IT:=1  {Se sim entao interrupcao de limite de enderecamento.}
   Else
    Begin
     Inc (MEM.REM); {Outro byte.}
     MEMORIA;       {Leia o byte de baixa ordem.}
     If Lo(PRC.REGISTRADOR [PRIM_OPERANDO]) < MEM.RDM
      Then
       PRC.CC:=4 {Registrador menor que a palavra da memoria.}
      Else
       If Lo(PRC.REGISTRADOR [PRIM_OPERANDO]) > MEM.RDM
        Then
         PRC.CC:=2  {Registrador maior que a palavra da memoria.}
        Else
         PRC.CC:=1  {Registrador igual a palavra da memoria.}
    End;
  Inc (PRC.CI,3) {Aponte para a nova intrucao.}
 End;

 Procedure CPL;                        {  Compara o registrador com a palavra
                                        de memoria apontada pelo segundo ope-
                                        rando, atualizando convenientemente o
                                        Codigo de Condicao.                  }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO,
  PALAVRA_DA_MEMORIA_FORMATO_WORD: Word;        {Variavel sem sinal.}
  PALAVRA_DA_MEMORIA_FORMATO_INTEGER: Integer;  {Variavel com sinal.}
   {Contera o valor da palavra de memoria.}

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  MEM.RWMEM:='R';
  MEM.REM:=PRC.BA+SEG_OPERANDO;
  If (MEM.REM+1) > PRC.LI {Ao ler a palavra inteira, vai estourar o limite? }
   Then
    PRC.IT:=1  {Se sim entao interrupcao de limite de enderecamento.}
   Else
    Begin
     MEMORIA;   {Se nao chame a memoria para ler o dado.}
     PALAVRA_DA_MEMORIA_FORMATO_WORD:=MEM.RDM*256;
     Inc (MEM.REM); {Outro byte.}
     MEMORIA;       {Leia o byte de baixa ordem.}
     Inc (PALAVRA_DA_MEMORIA_FORMATO_WORD, MEM.RDM); {Complete o seu valor.}
     PALAVRA_DA_MEMORIA_FORMATO_INTEGER:=PALAVRA_DA_MEMORIA_FORMATO_WORD;
      {Considera o sinal da palavra.}
     If PRC.REGISTRADOR [PRIM_OPERANDO] < PALAVRA_DA_MEMORIA_FORMATO_INTEGER
      Then
       PRC.CC:=4 {Registrador menor que a palavra da memoria.}
      Else
       If PRC.REGISTRADOR [PRIM_OPERANDO] > PALAVRA_DA_MEMORIA_FORMATO_INTEGER
        Then
         PRC.CC:=2  {Registrador maior que a palavra da memoria.}
        Else
         PRC.CC:=1 {Registrador igual a palavra da memoria.}
    End;
  Inc (PRC.CI,3) {Aponte para a nova intrucao.}
 End;

 Procedure CRB;                        { Carrega o byte indicado pelo segundo
                                        operando no byte de mais baixa  ordem
                                        do registrador indicado pelo primeiro
                                        operando.                            }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  MEM.RWMEM:='R';
  MEM.REM:=PRC.BA+SEG_OPERANDO;
  If (MEM.REM) > PRC.LI {Ao ler a palavra inteira, vai estourar o limite? }
   Then
    PRC.IT:=1  {Se sim entao interrupcao de limite de enderecamento.}
   Else
    Begin
     MEMORIA;   {Se nao chame a memoria para ler o dado.}
     PRC.REGISTRADOR [PRIM_OPERANDO]:=
      Hi (PRC.REGISTRADOR [PRIM_OPERANDO]) + MEM.RDM;
    End;
  Inc (PRC.CI,3) {Aponte para a nova intrucao.}
 End;

 Procedure CRP;                        { Carrega a palavra indicada pelo se-
                                        gundo operando no registrador  indi-
                                        cado pelo primeiro operando.        }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO,
  PALAVRA_DA_MEMORIA_FORMATO_WORD: Word;       {Variavel sem sinal. Contera o
                                                valor da palavra de memoria. }

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  MEM.RWMEM:='R';
  MEM.REM:=PRC.BA+SEG_OPERANDO;
  If (MEM.REM+1) > PRC.LI {Ao ler a palavra inteira, vai estourar o limite? }
   Then
    PRC.IT:=1  {Se sim entao interrupcao de limite de enderecamento.}
   Else
    Begin
     MEMORIA;   {Se nao chame a memoria para ler o dado.}
     PALAVRA_DA_MEMORIA_FORMATO_WORD:=MEM.RDM*256;
     Inc (MEM.REM); {Outro byte.}
     MEMORIA;       {Leia o byte de baixa ordem.}
     Inc (PALAVRA_DA_MEMORIA_FORMATO_WORD, MEM.RDM); {Complete o seu valor.}
     PRC.REGISTRADOR [PRIM_OPERANDO]:=PALAVRA_DA_MEMORIA_FORMATO_WORD;
    End;
  Inc (PRC.CI,3) {Aponte para a nova intrucao.}
 End;


 Procedure LMP;                        { Carrega zero no registrador indica-
                                        do pelo primeiro operando.          }

 Var

  PRIM_OPERANDO: Byte;

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  PRC.REGISTRADOR [PRIM_OPERANDO]:=0;
  Inc (PRC.CI,2)
 End;

 Procedure ABT;                        {  Transfere o byte de mais baixa ordem
                                        do registrador para o  byte  de  baixa
                                        ordem da palavra de  memoria  apontada
                                        pelo segundo operando.                }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  MEM.RWMEM:='W';                 { Procedimento de gravacao na memoria.  }
  MEM.REM:=PRC.BA+SEG_OPERANDO  ; { REM aponta para a palavra.            }
  If (MEM.REM+1) > PRC.LI         { Estorou o limite de memoria?          }
   Then
    PRC.IT:=1                     { Interrupcao de invasao de memoria.    }
   Else
    Begin
     Inc (MEM.REM);  {Gravar no byte menos significativo.}
     MEM.RDM:=Lo (PRC.REGISTRADOR [PRIM_OPERANDO]); {Executa a trasferencia.}
     MEMORIA;   {Grava na memoria.}
    End;
  Inc (PRC.CI,3) {Aponte para a proxima intrucao.}
 End;

 Procedure APL;                        { Armazena a palavra contida no regis-
                                        trador indicado pelo primeiro operan-
                                        do, na palavra indicada pelo segundo
                                        operando.                            }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  MEM.RWMEM:='W';
  MEM.REM:=PRC.BA+SEG_OPERANDO;
  If (MEM.REM+1) > PRC.LI {Ao ler a palavra inteira, vai estourar o limite? }
   Then
    PRC.IT:=1  {Se sim entao interrupcao de limite de enderecamento.}
   Else
    Begin
     MEM.RDM:=Hi (PRC.REGISTRADOR [PRIM_OPERANDO]);
     MEMORIA;   {Se nao chame a memoria para gravar o dado.}
     Inc (MEM.REM);
     MEM.RDM:=Lo (PRC.REGISTRADOR [PRIM_OPERANDO]);
     MEMORIA;       {Grave o byte de baixa ordem.}
    End;
  Inc (PRC.CI,3) {Aponte para a nova intrucao.}
 End;

 Procedure ESC;                        { Escreve avancando uma linha o con-
                                        teudo dos bytes indicados pelo  en-
                                        dereco no registrados indicado pelo
                                        primeiro operando. O numero de  by-
                                        tes a serem escritos esta armazena-
                                        do nos ultimos sete bits do segundo
                                        operando.                          }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;
  CONTADOR: Byte;           { Contador de uso interno.}

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  MEM.RWMEM:='R';
  SEG_OPERANDO:=SEG_OPERANDO and 127;  { 127 = (0000 0000 0111 1111)bin.}
  { Ignora tudo menos os sete ultimos bits do segundo operando.}
  MEM.REM:=PRC.BA+PRC.REGISTRADOR [PRIM_OPERANDO];
  If (MEM.REM + SEG_OPERANDO) > PRC.LI
   {Ao ler a palavra inteira, vai estourar o limite? }
   Then
    PRC.IT:=1  {Se sim entao interrupcao de limite de enderecamento.}
   Else
    Begin
     WriteLn;
     MEM.RWMEM:='R';
     Write ('Saida: ');
     For CONTADOR:=1 to SEG_OPERANDO do
      Begin
       MEMORIA;
       Write (Chr (MEM.RDM));
       Inc (MEM.REM)
      End
    End;
  Inc (PRC.CI, 3) {Aponte para a nova intrucao.}
 End;

 Procedure LE;                         { Recebe os bytes que deverao ser
                                        colocados no endereco do  regis-
                                        trador  indicado  pelo  primeiro
                                        operando. O numero de bytes  li-
                                        dos esta nos ultimos  sete  bits
                                        do segundo operando.            }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;
  CONTADOR: Byte;           { Contador de uso interno.}
  CARACTER: Char;           { Byte entrado pelo usuario.}
  ERRO: Integer;            { Pode haver uma entrada invalida
                             por parte do usuario.           }

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  MEM.REM:=PRC.BA + PRC.REGISTRADOR [PRIM_OPERANDO];
  SEG_OPERANDO:=SEG_OPERANDO and 127; { 127 = (0000 0000 0111 1111)bin.}
  { Ignora tudo menos os sete ultimos bits do segundo operando.}
  If (MEM.REM+SEG_OPERANDO) > PRC.LI
   {Ao ler a palavra inteira, vai estourar o limite? }
   Then
    PRC.IT:=1  {Se sim entao interrupcao de limite de enderecamento.}
   Else
    Begin
     WriteLn;
     MEM.RWMEM:='W';
     For CONTADOR:=1 to SEG_OPERANDO do
      Begin
       Write ('Entrar com o ',CONTADOR,' byte: ');
       ReadLn (CARACTER);
       MEM.RDM:=Ord (CARACTER);
       MEMORIA;
       Inc (MEM.REM)
      End
    End;
  Inc (PRC.CI, 3) {Aponte para a nova intrucao.}
 End;

 Procedure D;                          { Salta para o endereco  apontado pelo
                                        segundo operando se  a  operacao  and
                                        entre o primeiro operando e o Cod. de
                                        Condicao for maior que zero.         }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  If (PRC.CC and PRIM_OPERANDO) > 0
   Then
    If (PRC.BA + SEG_OPERANDO) > PRC.LI
     Then
      PRC.IT:=1                { Se nao estive entao faca uma interrupcao}
     Else
      PRC.CI:=PRC.BA + SEG_OPERANDO
      { Se estiver antes do limeite entao salte.}
   Else
    Inc (PRC.CI, 3)
 End;

 Procedure DSUB;                       { Carrega no registrador indicado pelo
                                        primeiro opernado o endereco da  pro-
                                        xima instrucao e salta para o endere-
                                        co indicado pelo segundo operando.   }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  PRC.REGISTRADOR [PRIM_OPERANDO]:=PRC.CI - PRC.BA + 3;
  { Endereco da proxima instrucao relativa ao registrador base.}
  If (PRC.BA + SEG_OPERANDO) > PRC.LI  { Estoura o limite de enderecamento?}
   Then
    PRC.IT:=1
   Else
    PRC.CI:= PRC.BA + SEG_OPERANDO { Executa o salto.}
 End;

 Procedure RET;                        { Desvia o fluxo de execucao  incon-
                                        dicionalmente  para  o  endereco
                                        indicado pelo registrador indicado
                                        pelo primeiro operando.           }

 Var

  PRIM_OPERANDO: Byte;

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  If (PRC.REGISTRADOR [PRIM_OPERANDO] + PRC.BA) > PRC.LI
   Then
    PRC.IT:=1
   Else
    PRC.CI:=PRC.REGISTRADOR [PRIM_OPERANDO] + PRC.BA;
  End;

 Procedure CVB;                        { Converte os primeiros cinco bytes
                                        indicados pelo segundo operando da
                                        forma ASCII para a forma  binaria.
                                        O resultado ficara no  registrador
                                        indicado pelo primeiro operando.  }

 Var

  PRIM_OPERANDO,
  SEG_OPERANDO: Integer;
  CONTADOR: Byte;             {  Contador de uso interno. }
  VALOR_NO_FORMATO_WORD: Word;{  Contera o valor total do conteudo do ende-
                                 co sem o sinal.                            }

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  MEM.RWMEM:='R';        { Indicativo de gravacao na memoria }
  MEM.REM:=PRC.BA + SEG_OPERANDO; { E passado o endereco de leirura. }
  If (MEM.REM+4) > PRC.LI
   Then
    PRC.IT:=1
   Else
    Begin
     VALOR_NO_FORMATO_WORD:=0;
     MEMORIA;
     Inc (VALOR_NO_FORMATO_WORD, (MEM.RDM - 48)*10000);
     Inc (MEM.REM);
     MEMORIA;
     Inc (VALOR_NO_FORMATO_WORD, (MEM.RDM - 48)*1000);
     Inc (MEM.REM);
     MEMORIA;
     Inc (VALOR_NO_FORMATO_WORD, (MEM.RDM - 48)*100);
     Inc (MEM.REM);
     MEMORIA;
     Inc (VALOR_NO_FORMATO_WORD, (MEM.RDM - 48)*10);
     Inc (MEM.REM);
     MEMORIA;
     Inc (VALOR_NO_FORMATO_WORD, (MEM.RDM - 48));
     PRC.REGISTRADOR [PRIM_OPERANDO]:=VALOR_NO_FORMATO_WORD
    End;
  Inc (PRC.CI,3) { Proxima instrucao.}
 End;

 Procedure CVD;                        {  Converte o valor contido no regitra-
                                        dor em forma ASCII e entao transfere a
                                        sequencia para a  posicao  de  memoria
                                        apontada pelo segundo operando.       }

 Var

  PRIM_OPERANDO,
  SEG_OPERANDO: Integer;
  VALOR_EM_ASCII: String [5]; {  Contem o agupamento de ASCII que representa
                               o numero contido no registrador.             }
  CONTADOR: Byte;             {  Contador de uso interno.                   }
  ERRO: Integer;              {  Variavel que contem o valor de erro. Obs:
                               Neste ambiente de uso da instrucao Val, nao
                               e possivel ocorreu um erro.                  }

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  MEM.RWMEM:='W';        { Indicativo de gravacao na memoria }
  MEM.REM:=PRC.BA + SEG_OPERANDO; { E passado o endereco de gravacao. }
  If (MEM.REM+4) > PRC.LI
   Then
    PRC.IT:=1
   Else
    Begin
     Str (PRC.REGISTRADOR [PRIM_OPERANDO]:5, VALOR_EM_ASCII);
     { Converte o valor do registrador em um string de cinco posicoes.}
     For CONTADOR:=0 TO 4 do  {Percorre as posicoes.}
      Begin
       Val (VALOR_EM_ASCII [CONTADOR+1], MEM.RDM, ERRO);
       { Pega o valor das casas centena, dezenas, etc separadamente.}
       Inc (MEM.RDM, 48);
       { Acrescenta uma constante para se obter o ASCII correspondente.}
       MEMORIA;
       Inc (MEM.REM) {Proxima posicao.}
      End
    End;
  Inc (PRC.CI,3) { Proxima instrucao.}
 End;

 Procedure CEND;                       { O endereco indicado pelo segundo
                                        operando e copiado para o  regis-
                                        trador  indicado  pelo  primeiro
                                        operando.                        }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  PRC.REGISTRADOR [PRIM_OPERANDO]:=SEG_OPERANDO;  {Transfere o endereco.}
  Inc (PRC.CI, 3)
 End;

 Procedure DCNT;                       { Decrementa o conteudo do registrador
                                        indicado pelo  primeiro  operando  em
                                        uma unidade. Se este registrador  fi-
                                        car com um valor diferente  de  zero,
                                        o fluxo do programa de desviara  para
                                        o endereco indicado pelo segundo ope-
                                        rando.                               }

 Var

  PRIM_OPERANDO: Byte;
  SEG_OPERANDO: Integer;

 Begin
  PRIM_OPERANDO:=LE_PRIM_OPERANDO;
  SEG_OPERANDO:=LE_SEG_OPERANDO;
  Dec (PRC.REGISTRADOR [PRIM_OPERANDO]);
  If PRC.REGISTRADOR [PRIM_OPERANDO] <> 0
   Then
    If (SEG_OPERANDO + PRC.BA) > PRC.LI
     Then
      PRC.IT:=1
     Else
      PRC.CI:=PRC.BA + SEG_OPERANDO
   Else
    Inc (PRC.CI,3)
 End;

 Procedure II;                         { Inibe as proximas interrupcoes.}
 Begin
  PRC.INTERRUPCAO:=False;
  Inc (PRC.CI)
 End;

 Procedure DI;                         { Desinibe as proximas interrupcoes.}
 Begin
  PRC.INTERRUPCAO:=True;
  Inc (PRC.CI) {Proxima instrucao.}
 End;

Begin
 SALVE_JANELA (1,1,10,50,JNL);
 MOLDURA (1,1,10,50,1);
 ClrScr;
 Write ('                   Execucao');    {Janela de execucao.}
 Window (2,3,49,9);
 PRC.INTERRUPCAO:=True;   {Interrupcao habilitada.}
 MEM.RWMEM:='R';
 MEM.REM:=0;
 MEMORIA;
 PRC.CI:=MEM.RDM*256;     {Soma a parte mais singnificativa do endereco.}
 MEM.REM:=1;
 MEMORIA;
 PRC.CI:=PRC.CI+MEM.RDM; {Soma a parte menos singnificativa do endereco.}
 {     O endereco da primeira palavra de memoria e
  passada para o Contador de Instrucao.              }
 PRC.IT:=0; {Nao exite nenhuma interrupcao ate agora.}
 Repeat
  PRC.RI:=LE_INSTRUCAO;  {Pega o codigo da instrucao.}
  Case PRC.RI of   {Escolhe a funcao a ser executada.}
   $01: SOMA;
   $02: SUB;
   $03: MUL;
   $04: DIVI;
   $05: DD;
   $06: DE;
   $07: CB;
   $08: CL;
   $09: E;
   $0A: OU;
   $0B: OUX;
   $0C: CBT;
   $0D: CPL;
   $0E: CRB;
   $0F: CRP;
   $10: LMP;
   $11: ABT;
   $12: APL;
   $13: ESC;
   $14: LE;
   $15: D;
   $16: DSUB;
   $17: RET;
   $18: CVB;
   $19: CVD;
   $1A: CEND;
   $1B: DCNT;
   $1C: II;
   $1D: DI;
  End;
 Until (PRC.RI=0) or ((PRC.IT<>0) and (PRC.INTERRUPCAO = true));
   { Executa o loop ate encontrar o  comando  de  parada  ou  se
    ouver uma interrupcao com a bandeira de interrupcoes  acesa,
    ou seja dando permicao para a ocorrencia de uma interrupcao.}
 If PRC.IT <> 0    {Houve interrupcao?}
  Then
   Begin
    MEM.REM:=6;
    MEM.RWMEM:='W';
    MEM.RDM:=Hi (PRC.CI);
    MEMORIA;
    Inc (MEM.REM);
    MEM.RDM:=Lo (PRC.CI);
    { Transfere o Contador de Instrucao
     para a palavra seis de memoria.   }
    MEM.REM:=4;
    MEM.RDM:=0;
    MEMORIA;
    Inc (MEM.REM);
    MEM.RDM:=PRC.IT;
    MEMORIA;
    { Transfere o codigo da interrupcao
     ocorrida para a palavra 4 da memo-
     ria. Se  nao  houver  interrupaco,
     ela ficara com o valor zerado.    }
    MEM.RWMEM:='R';
    MEM.REM:=2;
    MEMORIA;
    PRC.CI:=MEM.RDM * 256;
    Inc (MEM.REM);
    MEMORIA;
    Inc (PRC.CI, MEM.RDM);
    { O endereco da segunda palavra da
     memoria e passado para o contador
     de instrucao.  O  conteudo  desta
     palavra contem o endereco da  ro-
     tina de tratamento  de  interrup-
     coes.                            }
   End;
 WriteLn;
 Write ('Fim de execucao.');
 TECLA:=ReadKey;
 FECHE_JANELA (JNL);            {Fecha a janela de execucao.}
 Window (1,1,80,25)
End;

Begin
 CURSORX:=WhereX;
 CURSORY:=WhereY;
 SALVE_JANELA (1,1,25,80,JNL);
 ClrScr;
 SALVE_JANELA (5,20,16,60,JNL);   {Abre janela do menu}
 Repeat
  Window (1,1,80,25);
  MOLDURA (5,20,16,60,1);
  ClrScr;
  WriteLn ('    Simulador S83 <Menu de opcoes>');
  WriteLn ('    ');
  WriteLn;
  WriteLn ('      <1> Ler arquivo de dados.');
  WriteLn ('      <2> Processar programa.');
  WriteLn ('      <3> DUMP de memoria.');
  WriteLn ('      <4> Finalizar.');
  WriteLn;
  WriteLn ('         Sua Opcao [ ]');
  GotoXY (21, 9);
  OPCAO:=ReadKey;
  Write (OPCAO);
  If OPCAO = '1'
   Then
    LE_ARQUIVO;
  If OPCAO = '2'
   Then
    Begin
     PROCESSA;
     DUMP;
    End;
  If OPCAO = '3'
   Then
    DUMP;
 Until (OPCAO = '4');
 FECHE_JANELA (JNL);
 FECHE_JANELA (JNL);      {Retorne a tela do sistema.}
 Window (1,1,80,25);
 GotoXY (CURSORX, CURSORY)
End.

{  Carlos Fernando Bella Cruz.
   David Neufeld.
   Jeni Fon Switta.
   Silvia Satiko Toda.          }